#include <stdint.h>
#include <stdio.h>
#include <curl/curl.h>
#include <time.h>
#include <string.h>
#include <unistd.h>


const char INFLUXURL[] = "http://172.16.3.15:8086/write?db=smarthome2&precision=ms";

// #define BUFSIZE 131070
#define BUFSIZE 65535
char influxBuffer[BUFSIZE];
char *bufferNextEntry;

void influxInit() {
    memset(influxBuffer, 0, BUFSIZE);
    bufferNextEntry = influxBuffer;
}

static void influxSendRequest() {
//printf("About to send:\n");
//printf(influxBuffer);
    CURL *curl = curl_easy_init();
    if(curl) {
        curl_easy_setopt(curl, CURLOPT_URL, INFLUXURL);
        curl_easy_setopt(curl, CURLOPT_POSTFIELDS, influxBuffer);
        CURLcode res = curl_easy_perform(curl);
        if(res != CURLE_OK) {
            fprintf(stderr, "curl_easy_perform() failed: %s\n", curl_easy_strerror(res));
        }
        curl_easy_cleanup(curl);
    }
}

void influxAddFrequency(double f) {
    static uint32_t entries = 0;
    static uint32_t totalEntries = 0;
    char tmpBuf[128];
    struct timespec t;

    clock_gettime(CLOCK_REALTIME, &t);
    uint64_t tt = (((uint64_t)t.tv_sec) * 1000) + (((uint64_t)t.tv_nsec) / 1000000);
    int c = sprintf(tmpBuf, "mainsfrequency freq=%f %llu\n", f, tt);

    if ((bufferNextEntry + c + 10) > (influxBuffer + BUFSIZE)) {
        influxSendRequest();
        influxInit();
        totalEntries += entries;
        printf("%u entries sent to database, in total %u\n", entries, totalEntries);
        entries = 0;
    }

    memcpy(bufferNextEntry, tmpBuf, c);
    bufferNextEntry += c;
    entries++;
}


